# Copyright 2018 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by Magic Modules and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

# Builds a reference to a target HTTP proxy to be used in the global
# forwarding rule.
#
# Arguments:
#   - name: string
#     the name of the proxy
#   - project_name: string
#     the name of the project that hosts the proxy
#
# Examples:
#   - gcompute_target_http_proxy_ref('my-http-proxy', 'my-project')
Puppet::Functions.create_function(:gcompute_target_http_proxy_ref) do
  dispatch :gcompute_target_http_proxy_ref do
    param 'String', :name
    param 'String', :project_name
  end

  def gcompute_target_http_proxy_ref(name, project_name)
    URI.join('https://www.googleapis.com/compute/v1/',
             "projects/#{project_name}/global/targetHttpProxies/#{name}").to_s
  end
end
