# Copyright 2018 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by Magic Modules and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'google/compute/property/address_address'
require 'google/compute/property/boolean'
require 'google/compute/property/disk_name'
require 'google/compute/property/disktype_selflink'
require 'google/compute/property/enum'
require 'google/compute/property/instancetemplate_access_configs'
require 'google/compute/property/instancetemplate_alias_ip_ranges'
require 'google/compute/property/instancetemplate_disk_encryption_key'
require 'google/compute/property/instancetemplate_disks'
require 'google/compute/property/instancetemplate_guest_accelerators'
require 'google/compute/property/instancetemplate_initialize_params'
require 'google/compute/property/instancetemplate_network_interfaces'
require 'google/compute/property/instancetemplate_properties'
require 'google/compute/property/instancetemplate_scheduling'
require 'google/compute/property/instancetemplate_service_accounts'
require 'google/compute/property/instancetemplate_source_image_encryption_key'
require 'google/compute/property/instancetemplate_tags'
require 'google/compute/property/integer'
require 'google/compute/property/machinetype_name'
require 'google/compute/property/namevalues'
require 'google/compute/property/network_selflink'
require 'google/compute/property/string'
require 'google/compute/property/string_array'
require 'google/compute/property/subnetwork_selflink'
require 'google/compute/property/time'
require 'google/object_store'
require 'puppet'

Puppet::Type.newtype(:gcompute_instance_template) do
  @doc = <<-DOC
    Defines an Instance Template resource that provides configuration settings for your virtual
    machine instances. Instance templates are not tied to the lifetime of an instance and can be
    used and reused as to deploy virtual machines. You can also use different templates to create
    different virtual machine configurations. Instance templates are required when you create a
    managed instance group. Tip: Disks should be set to autoDelete=true so that leftover disks are
    not left behind on machine deletion.
  DOC

  autorequire(:gauth_credential) do
    credential = self[:credential]
    raise "#{ref}: required property 'credential' is missing" if credential.nil?
    [credential]
  end

  ensurable

  newparam :credential do
    desc <<-DESC
      A gauth_credential name to be used to authenticate with Google Cloud
      Platform.
    DESC
  end

  newparam(:project) do
    desc 'A Google Cloud Platform project to manage.'
  end

  newparam(:name, namevar: true) do
    # TODO(nelsona): Make this description to match the key of the object.
    desc 'The name of the InstanceTemplate.'
  end

  newproperty(:creation_timestamp, parent: Google::Compute::Property::Time) do
    desc 'Creation timestamp in RFC3339 text format. (output only)'
  end

  newproperty(:description, parent: Google::Compute::Property::String) do
    desc <<-DOC
      An optional description of this resource. Provide this property when you create the resource.
    DOC
  end

  newproperty(:id, parent: Google::Compute::Property::Integer) do
    desc <<-DOC
      The unique identifier for the resource. This identifier is defined by the server. (output
      only)
    DOC
  end

  newproperty(:name, parent: Google::Compute::Property::String) do
    desc 'Name of the resource. The name is 1-63 characters long and complies with RFC1035.'
  end

  newproperty(:properties, parent: Google::Compute::Property::InstanceTemplateProperties) do
    desc 'The instance properties for this instance template.'
  end

  # Returns all properties that a provider can export to other resources
  def exports
    provider.exports
  end
end
