# Copyright 2018 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by Magic Modules and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'spec_helper'

describe Puppet::Type.type(:gcompute_image).provider(:google) do
  before(:all) do
    cred = Google::FakeAuthorization.new
    Puppet::Type.type(:gauth_credential)
                .define_singleton_method(:fetch) { |_resource| cred }
  end

  it '#instances' do
    expect { described_class.instances }.to raise_error(StandardError,
                                                        /not supported/)
  end

  context 'ensure == present' do
    context 'resource exists' do
      # Ensure present: resource exists, no change
      context 'no changes == no action' do
        # Ensure present: resource exists, no change, no name
        context 'title == name' do
          # Ensure present: resource exists, no change, no name, pass
          context 'title == name (pass)' do
            before do
              allow(Time).to receive(:now).and_return(
                Time.new(2017, 1, 2, 3, 4, 5)
              )
              expect_network_get_success 1, name: 'title0'
              expect_network_get_success 2, name: 'title1'
              expect_network_get_success 3, name: 'title2'
              expect_network_get_success_zone 1
              expect_network_get_success_zone 2
              expect_network_get_success_zone 3
              expect_network_get_success_disk 1, zone: 'test name#0 data'
              expect_network_get_success_disk 2, zone: 'test name#1 data'
              expect_network_get_success_disk 3, zone: 'test name#2 data'
            end

            let(:catalog) do
              apply_with_error_check(
                <<-MANIFEST
                gcompute_zone { 'resource(zone,0)':
                  name       => 'test name#0 data',
                  project    => 'test project#0 data',
                  credential => 'cred0',
                }

                gcompute_zone { 'resource(zone,1)':
                  name       => 'test name#1 data',
                  project    => 'test project#1 data',
                  credential => 'cred1',
                }

                gcompute_zone { 'resource(zone,2)':
                  name       => 'test name#2 data',
                  project    => 'test project#2 data',
                  credential => 'cred2',
                }

                gcompute_disk { 'resource(disk,0)':
                  ensure     => present,
                  name       => 'test name#0 data',
                  zone       => 'resource(zone,0)',
                  project    => 'test project#0 data',
                  credential => 'cred0',
                }

                gcompute_disk { 'resource(disk,1)':
                  ensure     => present,
                  name       => 'test name#1 data',
                  zone       => 'resource(zone,1)',
                  project    => 'test project#1 data',
                  credential => 'cred1',
                }

                gcompute_disk { 'resource(disk,2)':
                  ensure     => present,
                  name       => 'test name#2 data',
                  zone       => 'resource(zone,2)',
                  project    => 'test project#2 data',
                  credential => 'cred2',
                }

                gcompute_image { 'title0':
                  ensure                     => present,
                  description                => 'test description#0 data',
                  disk_size_gb               => 450092159,
                  family                     => 'test family#0 data',
                  guest_os_features          => [
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                  ],
                  image_encryption_key       => {
                    raw_key => 'test raw_key#0 data',
                    sha256  => 'test sha256#0 data',
                  },
                  licenses                   => ['ww', 'xx'],
                  raw_disk                   => {
                    container_type => 'TAR',
                    sha1_checksum  => 'test sha1_checksum#0 data',
                    source         => 'test source#0 data',
                  },
                  source_disk                => 'resource(disk,0)',
                  source_disk_encryption_key => {
                    raw_key => 'test raw_key#0 data',
                    sha256  => 'test sha256#0 data',
                  },
                  source_disk_id             => 'test source_disk_id#0 data',
                  source_type                => 'RAW',
                  project                    => 'test project#0 data',
                  credential                 => 'cred0',
                }

                gcompute_image { 'title1':
                  ensure                     => present,
                  description                => 'test description#1 data',
                  disk_size_gb               => 900184319,
                  family                     => 'test family#1 data',
                  guest_os_features          => [
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                  ],
                  image_encryption_key       => {
                    raw_key => 'test raw_key#1 data',
                    sha256  => 'test sha256#1 data',
                  },
                  licenses                   => ['uu', 'vv'],
                  raw_disk                   => {
                    container_type => 'TAR',
                    sha1_checksum  => 'test sha1_checksum#1 data',
                    source         => 'test source#1 data',
                  },
                  source_disk                => 'resource(disk,1)',
                  source_disk_encryption_key => {
                    raw_key => 'test raw_key#1 data',
                    sha256  => 'test sha256#1 data',
                  },
                  source_disk_id             => 'test source_disk_id#1 data',
                  source_type                => 'RAW',
                  project                    => 'test project#1 data',
                  credential                 => 'cred1',
                }

                gcompute_image { 'title2':
                  ensure                     => present,
                  description                => 'test description#2 data',
                  disk_size_gb               => 1350276479,
                  family                     => 'test family#2 data',
                  guest_os_features          => [
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                  ],
                  image_encryption_key       => {
                    raw_key => 'test raw_key#2 data',
                    sha256  => 'test sha256#2 data',
                  },
                  licenses                   => ['tt', 'uu', 'vv'],
                  raw_disk                   => {
                    container_type => 'TAR',
                    sha1_checksum  => 'test sha1_checksum#2 data',
                    source         => 'test source#2 data',
                  },
                  source_disk                => 'resource(disk,2)',
                  source_disk_encryption_key => {
                    raw_key => 'test raw_key#2 data',
                    sha256  => 'test sha256#2 data',
                  },
                  source_disk_id             => 'test source_disk_id#2 data',
                  source_type                => 'RAW',
                  project                    => 'test project#2 data',
                  credential                 => 'cred2',
                }
                MANIFEST
              ).catalog
            end

            context 'Gcompute_image[title0]' do
              subject do
                catalog.resource('Gcompute_image[title0]').provider
              end

              it { is_expected.to have_attributes(archive_size_bytes: 2_242_826_196) }
              it do
                is_expected
                  .to have_attributes(creation_timestamp: ::Time.parse('2045-05-23T12:08:10+00:00'))
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'deprecated' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(description: 'test description#0 data') }
              it { is_expected.to have_attributes(disk_size_gb: 450_092_159) }
              it { is_expected.to have_attributes(family: 'test family#0 data') }
              # TODO(nelsonjr): Implement complex array object test.
              # it 'guestOsFeatures' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(id: 2_149_500_871) }
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'imageEncryptionKey' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(licenses: %w[ww xx]) }
              it { is_expected.to have_attributes(name: 'title0') }
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'rawDisk' do
              #   # Add test code here
              # end
              # TODO(alexstephen): Implement resourceref test.
              # it 'sourceDisk' do
              #   # Add test code here
              # end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'sourceDiskEncryptionKey' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(source_disk_id: 'test source_disk_id#0 data') }
              it { is_expected.to have_attributes(source_type: 'RAW') }
            end

            context 'Gcompute_image[title1]' do
              subject do
                catalog.resource('Gcompute_image[title1]').provider
              end

              it { is_expected.to have_attributes(archive_size_bytes: 4_485_652_393) }
              it do
                is_expected
                  .to have_attributes(creation_timestamp: ::Time.parse('2120-10-14T00:16:21+00:00'))
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'deprecated' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(description: 'test description#1 data') }
              it { is_expected.to have_attributes(disk_size_gb: 900_184_319) }
              it { is_expected.to have_attributes(family: 'test family#1 data') }
              # TODO(nelsonjr): Implement complex array object test.
              # it 'guestOsFeatures' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(id: 4_299_001_743) }
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'imageEncryptionKey' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(licenses: %w[uu vv]) }
              it { is_expected.to have_attributes(name: 'title1') }
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'rawDisk' do
              #   # Add test code here
              # end
              # TODO(alexstephen): Implement resourceref test.
              # it 'sourceDisk' do
              #   # Add test code here
              # end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'sourceDiskEncryptionKey' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(source_disk_id: 'test source_disk_id#1 data') }
              it { is_expected.to have_attributes(source_type: 'RAW') }
            end

            context 'Gcompute_image[title2]' do
              subject do
                catalog.resource('Gcompute_image[title2]').provider
              end

              it { is_expected.to have_attributes(archive_size_bytes: 6_728_478_589) }
              it do
                is_expected
                  .to have_attributes(creation_timestamp: ::Time.parse('2196-03-05T12:24:32+00:00'))
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'deprecated' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(description: 'test description#2 data') }
              it { is_expected.to have_attributes(disk_size_gb: 1_350_276_479) }
              it { is_expected.to have_attributes(family: 'test family#2 data') }
              # TODO(nelsonjr): Implement complex array object test.
              # it 'guestOsFeatures' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(id: 6_448_502_614) }
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'imageEncryptionKey' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(licenses: %w[tt uu vv]) }
              it { is_expected.to have_attributes(name: 'title2') }
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'rawDisk' do
              #   # Add test code here
              # end
              # TODO(alexstephen): Implement resourceref test.
              # it 'sourceDisk' do
              #   # Add test code here
              # end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'sourceDiskEncryptionKey' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(source_disk_id: 'test source_disk_id#2 data') }
              it { is_expected.to have_attributes(source_type: 'RAW') }
            end
          end

          # Ensure present: resource exists, no change, no name, fail
          context 'title == name (fail)' do
            # TODO(nelsonjr): Implement new test format.
            subject { -> { raise '[placeholder] This should fail.' } }
            it { is_expected.to raise_error(RuntimeError, /placeholder/) }
          end
        end

        # Ensure present: resource exists, no change, has name
        context 'title != name' do
          # Ensure present: resource exists, no change, has name, pass
          context 'title != name (pass)' do
            before do
              allow(Time).to receive(:now).and_return(
                Time.new(2017, 1, 2, 3, 4, 5)
              )
              expect_network_get_success 1
              expect_network_get_success 2
              expect_network_get_success 3
              expect_network_get_success_zone 1
              expect_network_get_success_zone 2
              expect_network_get_success_zone 3
              expect_network_get_success_disk 1, zone: 'test name#0 data'
              expect_network_get_success_disk 2, zone: 'test name#1 data'
              expect_network_get_success_disk 3, zone: 'test name#2 data'
            end

            let(:catalog) do
              apply_with_error_check(
                <<-MANIFEST
                gcompute_zone { 'resource(zone,0)':
                  name       => 'test name#0 data',
                  project    => 'test project#0 data',
                  credential => 'cred0',
                }

                gcompute_zone { 'resource(zone,1)':
                  name       => 'test name#1 data',
                  project    => 'test project#1 data',
                  credential => 'cred1',
                }

                gcompute_zone { 'resource(zone,2)':
                  name       => 'test name#2 data',
                  project    => 'test project#2 data',
                  credential => 'cred2',
                }

                gcompute_disk { 'resource(disk,0)':
                  ensure     => present,
                  name       => 'test name#0 data',
                  zone       => 'resource(zone,0)',
                  project    => 'test project#0 data',
                  credential => 'cred0',
                }

                gcompute_disk { 'resource(disk,1)':
                  ensure     => present,
                  name       => 'test name#1 data',
                  zone       => 'resource(zone,1)',
                  project    => 'test project#1 data',
                  credential => 'cred1',
                }

                gcompute_disk { 'resource(disk,2)':
                  ensure     => present,
                  name       => 'test name#2 data',
                  zone       => 'resource(zone,2)',
                  project    => 'test project#2 data',
                  credential => 'cred2',
                }

                gcompute_image { 'title0':
                  ensure                     => present,
                  description                => 'test description#0 data',
                  disk_size_gb               => 450092159,
                  family                     => 'test family#0 data',
                  guest_os_features          => [
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                  ],
                  image_encryption_key       => {
                    raw_key => 'test raw_key#0 data',
                    sha256  => 'test sha256#0 data',
                  },
                  licenses                   => ['ww', 'xx'],
                  name                       => 'test name#0 data',
                  raw_disk                   => {
                    container_type => 'TAR',
                    sha1_checksum  => 'test sha1_checksum#0 data',
                    source         => 'test source#0 data',
                  },
                  source_disk                => 'resource(disk,0)',
                  source_disk_encryption_key => {
                    raw_key => 'test raw_key#0 data',
                    sha256  => 'test sha256#0 data',
                  },
                  source_disk_id             => 'test source_disk_id#0 data',
                  source_type                => 'RAW',
                  project                    => 'test project#0 data',
                  credential                 => 'cred0',
                }

                gcompute_image { 'title1':
                  ensure                     => present,
                  description                => 'test description#1 data',
                  disk_size_gb               => 900184319,
                  family                     => 'test family#1 data',
                  guest_os_features          => [
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                  ],
                  image_encryption_key       => {
                    raw_key => 'test raw_key#1 data',
                    sha256  => 'test sha256#1 data',
                  },
                  licenses                   => ['uu', 'vv'],
                  name                       => 'test name#1 data',
                  raw_disk                   => {
                    container_type => 'TAR',
                    sha1_checksum  => 'test sha1_checksum#1 data',
                    source         => 'test source#1 data',
                  },
                  source_disk                => 'resource(disk,1)',
                  source_disk_encryption_key => {
                    raw_key => 'test raw_key#1 data',
                    sha256  => 'test sha256#1 data',
                  },
                  source_disk_id             => 'test source_disk_id#1 data',
                  source_type                => 'RAW',
                  project                    => 'test project#1 data',
                  credential                 => 'cred1',
                }

                gcompute_image { 'title2':
                  ensure                     => present,
                  description                => 'test description#2 data',
                  disk_size_gb               => 1350276479,
                  family                     => 'test family#2 data',
                  guest_os_features          => [
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                    {
                      type => 'VIRTIO_SCSI_MULTIQUEUE',
                    },
                  ],
                  image_encryption_key       => {
                    raw_key => 'test raw_key#2 data',
                    sha256  => 'test sha256#2 data',
                  },
                  licenses                   => ['tt', 'uu', 'vv'],
                  name                       => 'test name#2 data',
                  raw_disk                   => {
                    container_type => 'TAR',
                    sha1_checksum  => 'test sha1_checksum#2 data',
                    source         => 'test source#2 data',
                  },
                  source_disk                => 'resource(disk,2)',
                  source_disk_encryption_key => {
                    raw_key => 'test raw_key#2 data',
                    sha256  => 'test sha256#2 data',
                  },
                  source_disk_id             => 'test source_disk_id#2 data',
                  source_type                => 'RAW',
                  project                    => 'test project#2 data',
                  credential                 => 'cred2',
                }
                MANIFEST
              ).catalog
            end

            context 'Gcompute_image[title0]' do
              subject do
                catalog.resource('Gcompute_image[title0]').provider
              end

              it { is_expected.to have_attributes(archive_size_bytes: 2_242_826_196) }
              it do
                is_expected
                  .to have_attributes(creation_timestamp: ::Time.parse('2045-05-23T12:08:10+00:00'))
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'deprecated' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(description: 'test description#0 data') }
              it { is_expected.to have_attributes(disk_size_gb: 450_092_159) }
              it { is_expected.to have_attributes(family: 'test family#0 data') }
              # TODO(nelsonjr): Implement complex array object test.
              # it 'guestOsFeatures' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(id: 2_149_500_871) }
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'imageEncryptionKey' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(licenses: %w[ww xx]) }
              it { is_expected.to have_attributes(name: 'test name#0 data') }
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'rawDisk' do
              #   # Add test code here
              # end
              # TODO(alexstephen): Implement resourceref test.
              # it 'sourceDisk' do
              #   # Add test code here
              # end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'sourceDiskEncryptionKey' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(source_disk_id: 'test source_disk_id#0 data') }
              it { is_expected.to have_attributes(source_type: 'RAW') }
            end

            context 'Gcompute_image[title1]' do
              subject do
                catalog.resource('Gcompute_image[title1]').provider
              end

              it { is_expected.to have_attributes(archive_size_bytes: 4_485_652_393) }
              it do
                is_expected
                  .to have_attributes(creation_timestamp: ::Time.parse('2120-10-14T00:16:21+00:00'))
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'deprecated' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(description: 'test description#1 data') }
              it { is_expected.to have_attributes(disk_size_gb: 900_184_319) }
              it { is_expected.to have_attributes(family: 'test family#1 data') }
              # TODO(nelsonjr): Implement complex array object test.
              # it 'guestOsFeatures' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(id: 4_299_001_743) }
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'imageEncryptionKey' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(licenses: %w[uu vv]) }
              it { is_expected.to have_attributes(name: 'test name#1 data') }
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'rawDisk' do
              #   # Add test code here
              # end
              # TODO(alexstephen): Implement resourceref test.
              # it 'sourceDisk' do
              #   # Add test code here
              # end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'sourceDiskEncryptionKey' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(source_disk_id: 'test source_disk_id#1 data') }
              it { is_expected.to have_attributes(source_type: 'RAW') }
            end

            context 'Gcompute_image[title2]' do
              subject do
                catalog.resource('Gcompute_image[title2]').provider
              end

              it { is_expected.to have_attributes(archive_size_bytes: 6_728_478_589) }
              it do
                is_expected
                  .to have_attributes(creation_timestamp: ::Time.parse('2196-03-05T12:24:32+00:00'))
              end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'deprecated' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(description: 'test description#2 data') }
              it { is_expected.to have_attributes(disk_size_gb: 1_350_276_479) }
              it { is_expected.to have_attributes(family: 'test family#2 data') }
              # TODO(nelsonjr): Implement complex array object test.
              # it 'guestOsFeatures' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(id: 6_448_502_614) }
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'imageEncryptionKey' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(licenses: %w[tt uu vv]) }
              it { is_expected.to have_attributes(name: 'test name#2 data') }
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'rawDisk' do
              #   # Add test code here
              # end
              # TODO(alexstephen): Implement resourceref test.
              # it 'sourceDisk' do
              #   # Add test code here
              # end
              # TODO(nelsonjr): Implement complex nested property object test.
              # it 'sourceDiskEncryptionKey' do
              #   # Add test code here
              # end
              it { is_expected.to have_attributes(source_disk_id: 'test source_disk_id#2 data') }
              it { is_expected.to have_attributes(source_type: 'RAW') }
            end
          end

          # Ensure present: resource exists, no change, has name, fail
          context 'title != name (fail)' do
            # TODO(nelsonjr): Implement new test format.
            subject { -> { raise '[placeholder] This should fail.' } }
            it { is_expected.to raise_error(RuntimeError, /placeholder/) }
          end
        end
      end

      # Ensure present: resource exists, changes
      context 'changes == action' do
        # Ensure present: resource exists, changes, no name
        context 'title == name' do
          # Ensure present: resource exists, changes, no name, pass
          context 'title == name (pass)' do
            # TODO(nelsonjr): Implement new test format.
          end

          # Ensure present: resource exists, changes, no name, fail
          context 'title == name (fail)' do
            # TODO(nelsonjr): Implement new test format.
            subject { -> { raise '[placeholder] This should fail.' } }
            it { is_expected.to raise_error(RuntimeError, /placeholder/) }
          end
        end

        # Ensure present: resource exists, changes, has name
        context 'title != name' do
          # Ensure present: resource exists, changes, has name, pass
          context 'title != name (pass)' do
            # TODO(nelsonjr): Implement new test format.
          end

          # Ensure present: resource exists, changes, has name, fail
          context 'title != name (fail)' do
            # TODO(nelsonjr): Implement new test format.
            subject { -> { raise '[placeholder] This should fail.' } }
            it { is_expected.to raise_error(RuntimeError, /placeholder/) }
          end
        end
      end
    end

    context 'resource missing' do
      # Ensure present: resource missing, ignore, no name
      context 'title == name' do
        # Ensure present: resource missing, ignore, no name, pass
        context 'title == name (pass)' do
          before(:each) do
            expect_network_get_failed 1, name: 'title0'
            expect_network_create \
              1,
              {
                'kind' => 'compute#image',
                'description' => 'test description#0 data',
                'diskSizeGb' => 450_092_159,
                'family' => 'test family#0 data',
                'guestOsFeatures' => [
                  {
                    'type' => 'VIRTIO_SCSI_MULTIQUEUE'
                  },
                  {
                    'type' => 'VIRTIO_SCSI_MULTIQUEUE'
                  }
                ],
                'imageEncryptionKey' => {
                  'rawKey' => 'test raw_key#0 data',
                  'sha256' => 'test sha256#0 data'
                },
                'licenses' => %w[ww xx],
                'name' => 'title0',
                'rawDisk' => {
                  'containerType' => 'TAR',
                  'sha1Checksum' => 'test sha1_checksum#0 data',
                  'source' => 'test source#0 data'
                },
                'sourceDisk' => 'selflink(resource(disk,0))',
                'sourceDiskEncryptionKey' => {
                  'rawKey' => 'test raw_key#0 data',
                  'sha256' => 'test sha256#0 data'
                },
                'sourceDiskId' => 'test source_disk_id#0 data',
                'sourceType' => 'RAW'
              },
              name: 'title0'
            expect_network_get_async 1, name: 'title0'
            expect_network_get_success_zone 1
            expect_network_get_success_disk 1, zone: 'test name#0 data'
          end

          subject do
            apply_with_error_check(
              <<-MANIFEST
              gcompute_zone { 'resource(zone,0)':
                name       => 'test name#0 data',
                project    => 'test project#0 data',
                credential => 'cred0',
              }

              gcompute_disk { 'resource(disk,0)':
                ensure     => present,
                name       => 'test name#0 data',
                zone       => 'resource(zone,0)',
                project    => 'test project#0 data',
                credential => 'cred0',
              }

              gcompute_image { 'title0':
                ensure                     => present,
                description                => 'test description#0 data',
                disk_size_gb               => 450092159,
                family                     => 'test family#0 data',
                guest_os_features          => [
                  {
                    type => 'VIRTIO_SCSI_MULTIQUEUE',
                  },
                  {
                    type => 'VIRTIO_SCSI_MULTIQUEUE',
                  },
                ],
                image_encryption_key       => {
                  raw_key => 'test raw_key#0 data',
                  sha256  => 'test sha256#0 data',
                },
                licenses                   => ['ww', 'xx'],
                raw_disk                   => {
                  container_type => 'TAR',
                  sha1_checksum  => 'test sha1_checksum#0 data',
                  source         => 'test source#0 data',
                },
                source_disk                => 'resource(disk,0)',
                source_disk_encryption_key => {
                  raw_key => 'test raw_key#0 data',
                  sha256  => 'test sha256#0 data',
                },
                source_disk_id             => 'test source_disk_id#0 data',
                source_type                => 'RAW',
                project                    => 'test project#0 data',
                credential                 => 'cred0',
              }
              MANIFEST
            ).catalog.resource('Gcompute_image[title0]').provider.ensure
          end

          it { is_expected.to eq :present }
        end

        # Ensure present: resource missing, ignore, no name, fail
        context 'title == name (fail)' do
          # TODO(nelsonjr): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end

      # Ensure present: resource missing, ignore, has name
      context 'title != name' do
        # Ensure present: resource missing, ignore, has name, pass
        context 'title != name (pass)' do
          before(:each) do
            expect_network_get_failed 1
            expect_network_create \
              1,
              'kind' => 'compute#image',
              'description' => 'test description#0 data',
              'diskSizeGb' => 450_092_159,
              'family' => 'test family#0 data',
              'guestOsFeatures' => [
                {
                  'type' => 'VIRTIO_SCSI_MULTIQUEUE'
                },
                {
                  'type' => 'VIRTIO_SCSI_MULTIQUEUE'
                }
              ],
              'imageEncryptionKey' => {
                'rawKey' => 'test raw_key#0 data',
                'sha256' => 'test sha256#0 data'
              },
              'licenses' => %w[ww xx],
              'name' => 'test name#0 data',
              'rawDisk' => {
                'containerType' => 'TAR',
                'sha1Checksum' => 'test sha1_checksum#0 data',
                'source' => 'test source#0 data'
              },
              'sourceDisk' => 'selflink(resource(disk,0))',
              'sourceDiskEncryptionKey' => {
                'rawKey' => 'test raw_key#0 data',
                'sha256' => 'test sha256#0 data'
              },
              'sourceDiskId' => 'test source_disk_id#0 data',
              'sourceType' => 'RAW'
            expect_network_get_async 1
            expect_network_get_success_zone 1
            expect_network_get_success_disk 1, zone: 'test name#0 data'
          end

          subject do
            apply_with_error_check(
              <<-MANIFEST
              gcompute_zone { 'resource(zone,0)':
                name       => 'test name#0 data',
                project    => 'test project#0 data',
                credential => 'cred0',
              }

              gcompute_disk { 'resource(disk,0)':
                ensure     => present,
                name       => 'test name#0 data',
                zone       => 'resource(zone,0)',
                project    => 'test project#0 data',
                credential => 'cred0',
              }

              gcompute_image { 'title0':
                ensure                     => present,
                description                => 'test description#0 data',
                disk_size_gb               => 450092159,
                family                     => 'test family#0 data',
                guest_os_features          => [
                  {
                    type => 'VIRTIO_SCSI_MULTIQUEUE',
                  },
                  {
                    type => 'VIRTIO_SCSI_MULTIQUEUE',
                  },
                ],
                image_encryption_key       => {
                  raw_key => 'test raw_key#0 data',
                  sha256  => 'test sha256#0 data',
                },
                licenses                   => ['ww', 'xx'],
                name                       => 'test name#0 data',
                raw_disk                   => {
                  container_type => 'TAR',
                  sha1_checksum  => 'test sha1_checksum#0 data',
                  source         => 'test source#0 data',
                },
                source_disk                => 'resource(disk,0)',
                source_disk_encryption_key => {
                  raw_key => 'test raw_key#0 data',
                  sha256  => 'test sha256#0 data',
                },
                source_disk_id             => 'test source_disk_id#0 data',
                source_type                => 'RAW',
                project                    => 'test project#0 data',
                credential                 => 'cred0',
              }
              MANIFEST
            ).catalog.resource('Gcompute_image[title0]').provider.ensure
          end

          it { is_expected.to eq :present }
        end

        # Ensure present: resource missing, ignore, has name, fail
        context 'title != name (fail)' do
          # TODO(nelsonjr): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end
    end
  end

  context 'ensure == absent' do
    context 'resource missing' do
      # Ensure absent: resource missing, ignore, no name
      context 'title == name' do
        # Ensure absent: resource missing, ignore, no name, pass
        context 'title == name (pass)' do
          before(:each) do
            expect_network_get_failed 1, name: 'title0'
          end

          subject do
            apply_with_error_check(
              <<-MANIFEST
              gcompute_image { 'title0':
                ensure     => absent,
                project    => 'test project#0 data',
                credential => 'cred0',
              }
              MANIFEST
            ).catalog.resource('Gcompute_image[title0]')
              .provider.ensure
          end

          it { is_expected.to eq :absent }
        end

        # Ensure absent: resource missing, ignore, no name, fail
        context 'title == name (fail)' do
          # TODO(nelsonjr): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end

      # Ensure absent: resource missing, ignore, has name
      context 'title != name' do
        # Ensure absent: resource missing, ignore, has name, pass
        context 'title != name (pass)' do
          before(:each) do
            expect_network_get_failed 1
          end

          subject do
            apply_with_error_check(
              <<-MANIFEST
              gcompute_image { 'title0':
                ensure     => absent,
                name       => 'test name#0 data',
                project    => 'test project#0 data',
                credential => 'cred0',
              }
              MANIFEST
            ).catalog.resource('Gcompute_image[title0]')
              .provider.ensure
          end

          it { is_expected.to eq :absent }
        end

        # Ensure absent: resource missing, ignore, has name, fail
        context 'title != name (fail)' do
          # TODO(nelsonjr): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end
    end

    context 'resource exists' do
      # Ensure absent: resource exists, ignore, no name
      context 'title == name' do
        # Ensure absent: resource exists, ignore, no name, pass
        context 'title == name (pass)' do
          before(:each) do
            expect_network_get_success 1, name: 'title0'
            expect_network_delete 1, 'title0'
            expect_network_get_async 1, name: 'title0'
          end

          subject do
            apply_with_error_check(
              <<-MANIFEST
              gcompute_image { 'title0':
                ensure     => absent,
                project    => 'test project#0 data',
                credential => 'cred0',
              }
              MANIFEST
            ).catalog.resource('Gcompute_image[title0]')
              .provider.ensure
          end

          it { is_expected.to eq :absent }
        end

        # Ensure absent: resource exists, ignore, no name, fail
        context 'title == name (fail)' do
          # TODO(nelsonjr): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end

      # Ensure absent: resource exists, ignore, has name
      context 'title != name' do
        # Ensure absent: resource exists, ignore, has name, pass
        context 'title != name (pass)' do
          before(:each) do
            expect_network_get_success 1
            expect_network_delete 1
            expect_network_get_async 1
          end

          subject do
            apply_with_error_check(
              <<-MANIFEST
              gcompute_image { 'title0':
                ensure     => absent,
                name       => 'test name#0 data',
                project    => 'test project#0 data',
                credential => 'cred0',
              }
              MANIFEST
            ).catalog.resource('Gcompute_image[title0]')
              .provider.ensure
          end

          it { is_expected.to eq :absent }
        end

        # Ensure absent: resource exists, ignore, has name, fail
        context 'title != name (fail)' do
          # TODO(nelsonjr): Implement new test format.
          subject { -> { raise '[placeholder] This should fail.' } }
          it { is_expected.to raise_error(RuntimeError, /placeholder/) }
        end
      end
    end
  end

  context '#flush' do
    subject do
      Puppet::Type.type(:gcompute_image).new(
        ensure: :present,
        name: 'my-name'
      ).provider
    end
    context 'no-op' do
      it { subject.flush }
    end
    context 'modified object' do
      before do
        subject.dirty :some_property, 'current', 'newvalue'
      end
      context 'no-op if created' do
        before { subject.instance_variable_set(:@created, true) }
        it { expect { subject.flush }.not_to raise_error }
      end
      context 'no-op if deleted' do
        before { subject.instance_variable_set(:@deleted, true) }
        it { expect { subject.flush }.not_to raise_error }
      end
    end
  end

  private

  def expect_network_get_success(id, data = {})
    id_data = data.fetch(:name, '').include?('title') ? 'title' : 'name'
    body = load_network_result("success#{id}~#{id_data}.yaml").to_json

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! GET #{self_link(uri_data(id).merge(data))}"
    expect(Google::Compute::Network::Get).to receive(:new)
      .with(self_link(uri_data(id).merge(data)),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET #{args}"
      request
    end
  end

  def http_success(body)
    response = Net::HTTPOK.new(1.0, 200, 'OK')
    response.body = body
    response.instance_variable_set(:@read, true)
    response
  end

  def expect_network_get_async(id, data = {})
    body = { kind: 'compute#image' }.to_json

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! #{self_link(uri_data(id).merge(data))}"
    expect(Google::Compute::Network::Get).to receive(:new)
      .with(self_link(uri_data(id).merge(data)),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET <async> #{args}"
      request
    end
  end

  def expect_network_get_failed(id, data = {})
    request = double('request')
    allow(request).to receive(:send).and_return(http_failed_object_missing)

    debug_network "!! #{self_link(uri_data(id).merge(data))}"
    expect(Google::Compute::Network::Get).to receive(:new)
      .with(self_link(uri_data(id).merge(data)),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET [failed] #{args}"
      request
    end
  end

  def http_failed_object_missing
    Net::HTTPNotFound.new(1.0, 404, 'Not Found')
  end

  def expect_network_create(id, expected_body, data = {})
    merged_uri = uri_data(id).merge(data)
    body = { kind: 'compute#operation',
             status: 'DONE', targetLink: self_link(merged_uri) }.to_json

    # Remove refs that are also part of the body
    expected_body = Hash[expected_body.map do |k, v|
      [k.is_a?(Symbol) ? k.id2name : k, v]
    end]

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! POST #{collection(merged_uri)}"
    expect(Google::Compute::Network::Post).to receive(:new)
      .with(collection(merged_uri), instance_of(Google::FakeAuthorization),
            'application/json', expected_body.to_json) do |args|
      debug_network ">> POST #{args} = body(#{body})"
      request
    end
  end

  def expect_network_delete(id, name = nil, data = {})
    delete_data = uri_data(id).merge(data)
    delete_data[:name] = name unless name.nil?
    body = { kind: 'compute#operation',
             status: 'DONE',
             targetLink: self_link(delete_data) }.to_json

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! DELETE #{self_link(delete_data)}"
    expect(Google::Compute::Network::Delete).to receive(:new)
      .with(self_link(delete_data),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> DELETE #{args}"
      request
    end
  end

  def load_network_result(file)
    results = File.join(File.dirname(__FILE__), 'data', 'network',
                        'gcompute_image', file)
    debug("Loading result file: #{results}")
    raise "Network result data file #{results}" unless File.exist?(results)
    data = YAML.safe_load(File.read(results))
    raise "Invalid network results #{results}" unless data.class <= Hash
    data
  end

  def expect_network_get_success_disk(id, data = {})
    id_data = data.fetch(:name, '').include?('title') ? 'title' : 'name'
    body = load_network_result_disk("success#{id}~" \
                                                           "#{id_data}.yaml")
           .to_json
    uri = uri_data_disk(id).merge(data)

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! GET #{uri}"
    expect(Google::Compute::Network::Get).to receive(:new)
      .with(self_link_disk(uri),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET #{args}"
      request
    end
  end

  def load_network_result_disk(file)
    results = File.join(File.dirname(__FILE__), 'data', 'network',
                        'gcompute_disk', file)
    raise "Network result data file #{results}" unless File.exist?(results)
    data = YAML.safe_load(File.read(results))
    raise "Invalid network results #{results}" unless data.class <= Hash
    data
  end

  # Creates variable test data to comply with self_link URI parameters
  # Only used for gcompute_disk objects
  def uri_data_disk(id)
    {
      project: GoogleTests::Constants::D_PROJECT_DATA[(id - 1) \
        % GoogleTests::Constants::D_PROJECT_DATA.size],
      zone: GoogleTests::Constants::D_ZONE_DATA[(id - 1) \
        % GoogleTests::Constants::D_ZONE_DATA.size],
      name: GoogleTests::Constants::D_NAME_DATA[(id - 1) \
        % GoogleTests::Constants::D_NAME_DATA.size]
    }
  end

  def self_link_disk(data)
    URI.join(
      'https://www.googleapis.com/compute/v1/',
      expand_variables_disk(
        'projects/{{project}}/zones/{{zone}}/disks/{{name}}',
        data
      )
    )
  end

  def expect_network_get_success_zone(id, data = {})
    id_data = data.fetch(:name, '').include?('title') ? 'title' : 'name'
    body = load_network_result_zone("success#{id}~" \
                                                           "#{id_data}.yaml")
           .to_json
    uri = uri_data_zone(id).merge(data)

    request = double('request')
    allow(request).to receive(:send).and_return(http_success(body))

    debug_network "!! GET #{uri}"
    expect(Google::Compute::Network::Get).to receive(:new)
      .with(self_link_zone(uri),
            instance_of(Google::FakeAuthorization)) do |args|
      debug_network ">> GET #{args}"
      request
    end
  end

  def load_network_result_zone(file)
    results = File.join(File.dirname(__FILE__), 'data', 'network',
                        'gcompute_zone', file)
    raise "Network result data file #{results}" unless File.exist?(results)
    data = YAML.safe_load(File.read(results))
    raise "Invalid network results #{results}" unless data.class <= Hash
    data
  end

  # Creates variable test data to comply with self_link URI parameters
  # Only used for gcompute_zone objects
  def uri_data_zone(id)
    {
      project: GoogleTests::Constants::Z_PROJECT_DATA[(id - 1) \
        % GoogleTests::Constants::Z_PROJECT_DATA.size],
      name: GoogleTests::Constants::Z_NAME_DATA[(id - 1) \
        % GoogleTests::Constants::Z_NAME_DATA.size]
    }
  end

  def self_link_zone(data)
    URI.join(
      'https://www.googleapis.com/compute/v1/',
      expand_variables_zone(
        'projects/{{project}}/zones/{{name}}',
        data
      )
    )
  end

  def debug(message)
    puts(message) if ENV['RSPEC_DEBUG']
  end

  def debug_network(message)
    puts("Network #{message}") \
      if ENV['RSPEC_DEBUG'] || ENV['RSPEC_HTTP_VERBOSE']
  end

  def expand_variables_disk(template, data, ext_dat = {})
    Puppet::Type.type(:gcompute_disk).provider(:google)
                .expand_variables(template, data, ext_dat)
  end

  def expand_variables_zone(template, data, ext_dat = {})
    Puppet::Type.type(:gcompute_zone).provider(:google)
                .expand_variables(template, data, ext_dat)
  end

  def create_type(id)
    Puppet::Type.type(:gcompute_image).new(
      ensure: :present,
      title: "title#{id - 1}",
      credential: "cred#{id - 1}",
      project: GoogleTests::Constants::I_PROJECT_DATA[(id - 1) \
        % GoogleTests::Constants::I_PROJECT_DATA.size],
      name: GoogleTests::Constants::I_NAME_DATA[(id - 1) \
        % GoogleTests::Constants::I_NAME_DATA.size]
    )
  end

  def expand_variables(template, data, extra_data = {})
    Puppet::Type.type(:gcompute_image).provider(:google)
                .expand_variables(template, data, extra_data)
  end

  def collection(data)
    URI.join(
      'https://www.googleapis.com/compute/v1/',
      expand_variables(
        'projects/{{project}}/global/images',
        data
      )
    )
  end

  def self_link(data)
    URI.join(
      'https://www.googleapis.com/compute/v1/',
      expand_variables(
        'projects/{{project}}/global/images/{{name}}',
        data
      )
    )
  end

  # Creates variable test data to comply with self_link URI parameters
  def uri_data(id)
    {
      project: GoogleTests::Constants::I_PROJECT_DATA[(id - 1) \
        % GoogleTests::Constants::I_PROJECT_DATA.size],
      name: GoogleTests::Constants::I_NAME_DATA[(id - 1) \
        % GoogleTests::Constants::I_NAME_DATA.size]
    }
  end
end
